package com.bluerabbit.librarysystem.view;


import java.awt.Font;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.event.WindowEvent;
import java.io.File;
import java.util.ArrayList;
import java.util.Random;

import javax.swing.*;
import javax.swing.border.EtchedBorder;

import com.bluerabbit.librarysystem.beans.AdministratorBeans;
import com.bluerabbit.librarysystem.listener.MainView_AdminPhoto_MouseListener;
import com.bluerabbit.librarysystem.listener.MainView_Button1_MouseListener;
import com.bluerabbit.librarysystem.listener.MainView_Button2_MouseListener;
import com.bluerabbit.librarysystem.listener.MainView_Button3_MouseListener;
import com.bluerabbit.librarysystem.listener.MainView_Button4_MouseListener;
import com.bluerabbit.librarysystem.listener.MainView_exit_MouseListener;

/**
 * 
 *
 * @author minuhy
 */
public class MainView extends JFrame {
    /**
	 * UID
	 */
	private static final long serialVersionUID = -893839572059524069L;
	private static AdministratorBeans admin;
    private final JPanel mainWin;
    private final JLabel status;
    private final JLabel adminName;
    private final JLabel adminPhoto;
    private final JLabel adminBack;
    private final JLabel button1;
    private final JLabel button2;
    private final JLabel button3;
    private final JLabel button4;
    private final JLabel exit;
    
    // ûͷ
    private static String avater;

    /**
     * 
     */
    public MainView(AdministratorBeans admin) {
        MainView.admin = admin;
        mainWin = new JPanel() {
            /**
			 * 
			 */
			private static final long serialVersionUID = 1858000266892218472L;

			@Override
            protected void paintComponent(Graphics g) {
                Image img = new ImageIcon("res/background2.png").getImage();
                g.drawImage(img, 0, 0, this.getWidth(), this.getHeight(), this);
            }
        };

        adminName = new JLabel();
        adminPhoto = new JLabel();
        adminBack = new JLabel();
        button1 = new JLabel("Ĺ");
        button2 = new JLabel("߹");
        button3 = new JLabel("ͼ");
        button4 = new JLabel("Ա");
        status = new JLabel();

        exit = new JLabel();

        Init();
    }

    private void Init() {
        //ñ
        this.setTitle("ͼϵͳ - ");
        //ôڴС
        this.setSize(1152, 679);
        //עر¼
        this.setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
        //ھ
        CenterView.CenterByWindow(this);
        //ַʽΪղ
        mainWin.setLayout(null);

        //ûڴС
        this.setResizable(false);


        //û
        adminName.setBounds(70, 0, 600, 30);
        adminName.setFont(new Font("΢ź", Font.BOLD, 27));

        status.setBounds(70, 40, 100, 30);
        status.setFont(new Font("΢ź", Font.BOLD | Font.ITALIC, 17));

        adminName.setText(admin.getAdminName());
        if (admin.isIfsuper()) {
            status.setText("Ա");
        } else {
            status.setText("Ա");
        }

        ArrayList<String> avatars;
        int avatarIndex;
        // ͷ
        {
            String basePath = "res/avatar/";
            File dir = new File(basePath);
            avatars = new ArrayList<>();
            if (dir.exists()) {
                getAllFilePath(dir, avatars);
            } else {
                System.out.println("ͷĿ¼");
                avatars.add("res/photo1.png");
            }

            Random random = new Random();
            avatarIndex = random.nextInt(avatars.size());

            avater = avatars.get(avatarIndex);
            System.out.println("ͷ" + avater);
        }
        //ͷ
        setJLabelImageAndSize(5, 5, 60, 60, adminPhoto, avater);

        adminPhoto.setBorder(BorderFactory.createEtchedBorder(EtchedBorder.LOWERED));
        //Ƭ
        setJLabelImageAndSize(0, 0, 1098, 80, adminBack, "res/titlebackground.png");
        //Ĺ
        setJLabelImageAndSize(90, 120, 350, 430, button1, "res/main/1/default.png");
        //button1.setBorder(BorderFactory.createEtchedBorder(EtchedBorder.LOWERED));
        //߹
        setJLabelImageAndSize(460, 120, 250, 430, button2, "res/main/2/default.png");
        //button2.setBorder(BorderFactory.createEtchedBorder(EtchedBorder.LOWERED));
        //ͼ
        setJLabelImageAndSize(730, 120, 275, 210, button3, "res/main/3/default.png");
        //button3.setBorder(BorderFactory.createEtchedBorder(EtchedBorder.LOWERED));
        //Ա
        setJLabelImageAndSize(730, 350, 275, 200, button4, "res/main/4/default.png");
        //button4.setBorder(BorderFactory.createEtchedBorder(EtchedBorder.LOWERED));
        //˳¼
        setJLabelImageAndSize(910, 10, 170, 57, exit, "res/exit1.png");
        //exit.setBorder(BorderFactory.createEtchedBorder(EtchedBorder.LOWERED));


        adminPhoto.addMouseListener(new MainView_AdminPhoto_MouseListener(this, admin));
        button1.addMouseListener(new MainView_Button1_MouseListener(this));
        button2.addMouseListener(new MainView_Button2_MouseListener(this));
        button3.addMouseListener(new MainView_Button3_MouseListener(this));
        button4.addMouseListener(new MainView_Button4_MouseListener(this));
        exit.addMouseListener(new MainView_exit_MouseListener(this, exit));


        mainWin.add(status);
        mainWin.add(adminPhoto);
        mainWin.add(adminName);
        mainWin.add(button4);
        mainWin.add(button3);
        mainWin.add(button2);
        mainWin.add(button1);
        mainWin.add(exit);

        mainWin.add(adminBack);

        this.add(mainWin);
        //ôڿɼ
        this.setVisible(true);
    }

    public void setJLabelImageAndSize(int x, int y, int width, int height, JLabel label, String imagePath) {
        //ʵImageIcon 
        ImageIcon image = new ImageIcon(imagePath);
        //õImage
        Image img = image.getImage();
        //Ű汾
        img = img.getScaledInstance(width, height, Image.SCALE_DEFAULT);
        //滻ΪŰ汾
        image.setImage(img);
        //JLabelͼ
        label.setIcon(image);
        //JLabelʹС
        label.setBounds(x, y, width, height);
    }

    /**
     * дڵ¼תǴprocessWindowEvent뵽ڹر¼
     */
    @Override
    protected void processWindowEvent(WindowEvent e) {
        //ҪԽWindowEventжϣΪдڹرյWindowEventWindowEvent
        if (e.getID() == WindowEvent.WINDOW_CLOSING) {
            int option = JOptionPane.showConfirmDialog(null, "Ƿرճ", "˳ʾ", JOptionPane.OK_CANCEL_OPTION);
            if (option == JOptionPane.OK_OPTION) {
                //ûѡرճϴʾȷϴദ
                super.processWindowEvent(e);
            }
            //ûѡ˳ѹر¼ȡ
        } else {
            //¼ദ
            super.processWindowEvent(e);
        }
    }

    public JLabel getButton1() {
        return button1;
    }

    public JLabel getButton2() {
        return button2;
    }

    public JLabel getButton3() {
        return button3;
    }

    public JLabel getButton4() {
        return button4;
    }

    public void updateAdmin(AdministratorBeans admin) {
        MainView.admin = admin;
        adminName.setText(admin.getAdminName());
        if (admin.isIfsuper()) {
            status.setText("Ա");
        } else {
            status.setText("Ա");
        }
    }

    public boolean isSu() {
        return admin.isIfsuper();
    }

    public String getAdminAcc() {
        return admin.getAccount();
    }


    public static void getAllFilePath(File dir, ArrayList<String> files) {
        // ȡļб
        File[] fileList = dir.listFiles();
        assert fileList != null;
        for (File file : fileList) {
            if (file.isDirectory()) {
                // ݹ鴦ļ
                // ͳļԽһע͵
                getAllFilePath(file, files);
            } else {
                // ļ뵽ļ
                files.add(file.getPath());
            }
        }
    }
    
    
    public static String getAvater() {
		return avater;
	}

	public static AdministratorBeans getAdmin() {
        return admin;
    }
}

